%% P_function_first_response.m calculates the P matrix based on input values
% This function is the underlying calculator of the main script
% Preservation.m that produces the preservation matrix P(m*m*m). Input
% variables are first response time t and accident type a.

function P = P_function_first_response(t,a)

%% Paramters
global A B

%% Calcualtion
% Conditioned preservation parameter calculations as the decrease changes
% with the first response

% Traffic accident: first response only, linear decrease 
if a == 2 
    P = 1 - B(a)*t;  

% Water accident: first response only, exponential decrease
%elseif a == 3
%    P = exp(-(A(a)*(t)));

% Other accidents: first response only, linear decrease (slower than for
% traffic accidents)
%elseif a == 4
%    P = 1 - B(a)*t;
end  % If

% Checking non-zero condition: if P is negative, the value is set to zero
if P < 0
    P = 0;
end  % If

end  % Function 