%% P_function_full_response.m calculates the P matrix based on input values
% This function is the underlying calculator of the main script
% Preservation.m that produces the preservation matrix P(m*m*m*m). Input
% variables are first response time t1 and full response time t2 and
% accident type a.

function P = P_function_last_response(t1,t2,a)
%% Paramters
global A B

%% Calcualtion
% Conditioned preservation parameter calculations as the decrease changes
% with the first response

% Total response is achived at the arrival of the second unit
if a == 1
    P = exp(-A(a)*(t1)) + (-B(a)*(t2-t1));        
end  % If

% Checking non-zero condition: if P is negative, the value is set to zero
if P < 0
    P = 0;
end  % If

end  % Function 