import math
# Files
RequiredUnit = open('RequiredUnit.txt','r')
UnitInZone = open('UnitInZone_P2.2.txt','r')
Traveltime = open('Traveltime.txt','r')


def getMaxTraveltime(matrix):
    maxValue = 0
    for i in matrix:
        for j in i:
            if j > maxValue:
                maxValue = j
    return maxValue

def getAverageResponseTime(traveltimeFile,unitInZoneFile,requiredUnitFile):
    traveltimeMatrix = getMatrixFromTextFile(traveltimeFile)
    unitInZoneMatrix = getMatrixFromTextFile(unitInZoneFile)
    requiredUnitMatrix = getMatrixFromTextFile(requiredUnitFile)

    nZones = len(traveltimeMatrix)
    nUnits = len(unitInZoneMatrix[0])
    nAccidentTypes = len(requiredUnitMatrix)
    sumTravelTimes = 0
    for a in range(0,nAccidentTypes):
        for i in range(0,nZones):
            minTraveltime = getMaxTraveltime(traveltimeMatrix)
            for u in range(0,nUnits):
                for j in range(0,nZones):
                    if(requiredUnitMatrix[a][u]==1 and unitInZoneMatrix[j][u]==1 and traveltimeMatrix[i][j]<minTraveltime):
                        minTraveltime = traveltimeMatrix[i][j]
            sumTravelTimes += minTraveltime
    averageTraveltime = sumTravelTimes/(nZones*nAccidentTypes)
    return averageTraveltime

def getMatrixFromTextFile(textFile):
    matrix = map(lambda x: x.split(), textFile.readlines())
    matrix2 = [map(float,x) for x in matrix]
    return matrix2

print (getAverageResponseTime(Traveltime,UnitInZone,RequiredUnit))


RequiredUnit.close() # Close file
UnitInZone.close()
Traveltime.close()
