# This Python code gets postal code to addresses using a Google Maps API

import urllib2
import json
import csv

# API KEY connected to ip address
API_KEY = "AIzaSyCV2rCMQlu-QRpIiX-M68esnEbxCgDQf5I"

# File with addresses for all zones
inputFile = open('addresses.txt','r')

# Return travel time from a html source
def getPostalCode(data):
    for items in data["results"]:
        for item in items["address_components"]:
            if item["types"][0] == "postal_code":
                postalCode = item.get("long_name")
                return postalCode


# Get coordinates for all zones from an inputfile and retrieves a matrix
# with calculated travel times between all zones
def PostalCodeMatrix(textFile):
    # Each line represent coordinates for a given zoe
    lines = textFile.read().splitlines()
    # Number of zones
    numberoflines = len(lines)
    # Create empty matrix
    matrix = []

    # Connect to Google Maps API and get travel times between all zones
    #for i in lines:
    for i in range(0,numberoflines):
        matrix_row = []
        #address = i
        address = lines[i]
        url = "https://maps.googleapis.com/maps/api/geocode/json?address=" + address + ",+Oslo&key=" + API_KEY
        html = urllib2.urlopen(url)
        data = json.load(html)
        try:
            # Inserting postal code in matrix
            matrix_row.append(getPostalCode(data))
            #print postalCode
        except:
            matrix_row.append(0)
            #print("Couldt find postal code")
        matrix.append(matrix_row[0])
    print matrix
    return matrix
# https://maps.googleapis.com/maps/api/geocode/json?address=MORTENSRUDVEIEN+138,+Oslo&key=AIzaSyCV2rCMQlu-QRpIiX-M68esnEbxCgDQf5I

# Write values in input matrix to a csv file
def writeToCsv(matrix):
    file = open('postalcodes.csv', 'wb')
    writer = csv.writer(file)
    writer.writerow(matrix)
    file.close() 

# Run method writeToCsv with matrix generated based on file with
# coordinates 
writeToCsv(PostalCodeMatrix(inputFile))

inputFile.close() # Close file
