# This Python code gets GPS coordinates to all postal codes in the city of Trondheim and calculates the travel time between all zones using a Google Maps API

import urllib2
import json
import csv

# API KEY connected to ip address
API_KEY = 'AIzaSyAyyA-CmjdjIs3mh1c68DxW1tvaOWjGA9o'

# File with GPS coordinates for all zones
input_file_lat = open('Coordinates_lat.txt','r')
input_file_lon = open('Coordinates_lon.txt','r')

# Return travel time from a html source
def get_travel_time(data):
    for items in data['rows']:
        for item in items['elements']:
            travel_time_text = item['duration'].get('text')
            travel_time_text = travel_time_text.split(' ')
            travel_time = travel_time_text[0]
            return travel_time

# Get coordinates for all zones from an inputfile and retrieves a matrix
# with calculated travel times between all zones
def get_travel_time_matrix(textfile_lat, textfile_lon):
    
    # Each line represent coordinates for a given zoe
    lines_lat = textfile_lat.read().splitlines()
    lines_lon = textfile_lon.read().splitlines()
    # Number of zones
    number_of_lines = len(lines_lat)
    # Create empty matrix
    matrix = []

    # Connect to Google Maps API and get travel times between all zones
    for i in range(5,10):
        matrix_row = []
        for j in range(0,number_of_lines):
            origin_lat = lines_lat[i]
            origin_lon = lines_lon[i]
            destination_lat = lines_lat[j]
            destination_lon = lines_lon[j]
            url = 'https://maps.googleapis.com/maps/api/distancematrix/json?origins=' + origin_lat + ',' + origin_lon + '&destinations=' + destination_lat + ',' + destination_lon + '&key=' + API_KEY
            html = urllib2.urlopen(url)
            data = json.load(html)
            try:
                # Inserting travel time in matrix_row
                matrix_row.append(get_travel_time(data))
            except:
                matrix_row.append(0)
                print('Unable to find duration between zones')
        # Adding row with travel times to matrix
        matrix.append(matrix_row)
    return matrix

# Write values in input matrix to a csv file
def write_to_CSV(matrix):
    file = open('Traveltimes.csv', 'wb')
    writer = csv.writer(file)
    for row in matrix:
        writer.writerow(row)
    file.close() 

# Run method writeToCsv with matrix generated based on file with
# coordinates 
write_to_CSV(get_travel_time_matrix(input_file_lat, input_file_lon))

# Close files
input_file_lat.close()
input_file_lon.close()

#https://maps.googleapis.com/maps/api/distancematrix/json?origins=59.9171,10.7274&destinations=59.9171,10.7274&key=AIzaSyAyyA-CmjdjIs3mh1c68DxW1tvaOWjGA9o
